package com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour;

//Activity that displays all current admins and buildings, gives user the option to add/update/or delete each

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.MalformedInputException;

public class Admin_Main extends AppCompatActivity {

    //json_string for admins
    String json_string1;
    JSONObject jsonObject1;
    JSONArray jsonArray1;
    ContactAdapter contactAdapter1;
    ListView listView1;

    //json_string for buildings
    String json_string2;
    JSONObject jsonObject2;
    JSONArray jsonArray2;
    ContactAdapter2 contactAdapter2;
    ListView listView2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_admin__main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setTitle("Admin Home"); //set page title

        //initate and populate listview for admins
        listView1 = (ListView) findViewById(R.id.listView);
        contactAdapter1 = new ContactAdapter(this, R.layout.admin_listview);
        listView1.setAdapter(contactAdapter1);
        json_string1 = getIntent().getExtras().getString("json_data");
        try {
            jsonObject1 = new JSONObject(json_string1);
            jsonArray1 = jsonObject1.getJSONArray("result");
            int count = 0;
            String id, email, password;

            while(count < jsonArray1.length())
            {
                JSONObject JO = jsonArray1.getJSONObject(count);
                id = JO.getString("admin_id");
                email = JO.getString("email");
                password = JO.getString("password");
                Contacts contacts = new Contacts(id, email, password); //create contact
                contactAdapter1.add(contacts); //add contacts

                count++;
            }
        }

        catch (JSONException e) {
            e.printStackTrace();
        }

        //if listview item is clicked, go to deleteUpdateAdmin activity
        listView1.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //Toast.makeText(Admin_Main.this, Integer.toString(position), Toast.LENGTH_SHORT).show();
                deleteUpdateAdmin(position);
            }
        });

        //initate and populate listview for buildings
        listView2 = (ListView) findViewById(R.id.listView2);
        contactAdapter2 = new ContactAdapter2(this, R.layout.buildings_listview);
        listView2.setAdapter(contactAdapter2);
        json_string2 = getIntent().getExtras().getString("json_building_data");
        try {
            jsonObject2 = new JSONObject(json_string2);
            jsonArray2 = jsonObject2.getJSONArray("result");
            int count = 0;
            String id, type, name, lat, log;

            while(count < jsonArray2.length())
            {
                JSONObject JO = jsonArray2.getJSONObject(count);
                id = JO.getString("building_id");
                type = JO.getString("building_type_id");
                name = JO.getString("building_name");
                lat = JO.getString("building_lat");
                log = JO.getString("building_long");
                Contacts contacts = new Contacts(id, type, name, lat, log); //create new contact
                contactAdapter2.add(contacts); //add contact

                count++;
            }
        }
        catch (JSONException e) {
            e.printStackTrace();
        }

        //if listview item is clicked, go to deleteUpdatebuildings activity
        listView2.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //Toast.makeText(Admin_Main.this, Integer.toString(position), Toast.LENGTH_SHORT).show();
                deleteUpdateBuildings(position);
            }
        });
    }

    //overrides back button to send back to home page of app
    @Override
    public void onBackPressed(){
        Intent intent = new Intent(this, SNC_Augemented_Reality_Virtual_Tour.class);
        startActivity(intent);
    }

    //if insert admin button selected
    public void insertAdmin(View view)
    {
        Intent intent = new Intent(this, Create_Admin.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //if admin listview item is selected
    public void deleteUpdateAdmin(Integer position) {

        String position2 = Integer.toString(position);
        Intent intent = new Intent(this, Delete_Update_Admin.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        intent.putExtra("position", position2);
        startActivity(intent);
    }

    //if insert building button selected
    public void insertBuilding(View view)
    {
        Intent intent = new Intent(this, Create_Building.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //if building listview item is selected
    public void deleteUpdateBuildings(Integer position)
    {
        String position2 = Integer.toString(position);
        Intent intent = new Intent(this, Delete_Update_Building.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        intent.putExtra("position", position2);
        startActivity(intent);
    }
}
