package com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour;

//Activity that gives the user the option to delete or update a certain admin

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.MalformedInputException;

public class Delete_Update_Admin extends AppCompatActivity {

    //varibales for json data
    String json_string1;
    String json_string2;
    JSONObject jsonObject1;
    JSONArray jsonArray1;

    String pos;
    int position;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.content_delete__update__admin);

        String id = null, email = null, password = null;

        //retrieves json data and position data from intent
        json_string1 = getIntent().getExtras().getString("json_data");
        json_string2 = getIntent().getExtras().getString("json_building_data");
        pos = getIntent().getExtras().getString("position");
        position = Integer.parseInt(pos);

        try {
            jsonObject1 = new JSONObject(json_string1);
            jsonArray1 = jsonObject1.getJSONArray("result");

            int count = 0;

            //goes through json string until selected admin is choosen to set email as a textview on the screen
            while (count <= position) {
                JSONObject JO = jsonArray1.getJSONObject(count);
                id = JO.getString("admin_id");
                email = JO.getString("email");
                password = JO.getString("password");

                count++;
            }
        }catch(JSONException e){
            e.printStackTrace();
        }

        //set selected email in the textview
        TextView emailText = (TextView)findViewById(R.id.adminEmail);
        emailText.setText(email);
    }

    //overrides back button to send user back to admin main activity
    @Override
    public void onBackPressed(){
        Intent intent = new Intent(this, Admin_Main.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //when delete button is pressed
    public void deleteAdmin(View view) {
        String id = null, email = null, password = null;

        try {
            jsonObject1 = new JSONObject(json_string1);
            jsonArray1 = jsonObject1.getJSONArray("result");

            //makes sure that the last admin value is not deleted
            if (jsonArray1.length() < 2) {
                Toast.makeText(this, "Cannot Delete The Last Admin", Toast.LENGTH_SHORT).show();

                String position2 = Integer.toString(position);
                Intent intent = new Intent(this, Delete_Update_Admin.class);
                intent.putExtra("json_data", json_string1);
                intent.putExtra("json_building_data", json_string2);
                intent.putExtra("position", position2);
                startActivity(intent);

            } else {
                int count = 0;

                //increments until the selected admin is arrived to in the json_string
                while (count <= position) {
                    JSONObject JO = jsonArray1.getJSONObject(count);
                    id = JO.getString("admin_id");
                    email = JO.getString("email");
                    password = JO.getString("password");

                    count++;
                }
            }
        }catch(JSONException e){
            e.printStackTrace();
        }

        //doesn't allow user to delete final admin from for the app
        if (jsonArray1.length() >= 2) {
            //calls php script that deletes admin from the database
            BackgroundTask backgroundTask = new BackgroundTask(this);
            backgroundTask.execute(id);
        }
    }

    //when update button selected, moves to updated admin activity
    public void updateAdmin(View view)
    {
        String position2 = Integer.toString(position);
        Intent intent = new Intent(this, Update_Admin.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        intent.putExtra("position", position2);
        startActivity(intent);
    }

    //returns user to admin main activity
    public void returnToAdminMain()
    {
        Intent intent = new Intent(this, Admin_Main.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //calls php script that deletes admin from the database
    public class BackgroundTask extends AsyncTask<String, Void, String> {

        Context ctx;
        BackgroundTask(Context ctx){
            this.ctx = ctx;
        }
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            String id = params[0];

            try{
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/delete_admins.php");
                //opens http connection, output stream, and buffer
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setDoOutput(true);
                OutputStream OS = httpURLConnection.getOutputStream();
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(OS, "UTF-8"));
                String data = URLEncoder.encode("admin_id", "UTF-8") +"="+URLEncoder.encode(id, "UTF-8");
                bufferedWriter.write(data);
                bufferedWriter.flush();

                //closes buffer and output stream
                bufferedWriter.close();
                OS.close();
                InputStream IS = httpURLConnection.getInputStream();
                IS.close();
            } catch (MalformedInputException e){
                e.printStackTrace();
            } catch (IOException e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //Toast.makeText(ctx, result, Toast.LENGTH_LONG).show();
            //gets updated json string of admins table in databse post deletion
            new BackgroundTask1().execute();
        }
    }

    //retrieves updated json string of admins following deletion of an admin
    class BackgroundTask1 extends AsyncTask<Void, Void, String>
    {
        String JSON_String;

        @Override
        protected String doInBackground(Void... params) {
            try {
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/admin_login.php");

                //opens http connect, input stream, and buffer
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferReader = new BufferedReader(new InputStreamReader(inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while((JSON_String = bufferReader.readLine())!= null)
                {
                    stringBuilder.append(JSON_String + "\n");
                }

                //closes buffer, input stream, and http connection
                bufferReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                json_string1 = stringBuilder.toString().trim();
                return stringBuilder.toString().trim();
            } catch (MalformedInputException e){
                e.printStackTrace();
            } catch (IOException e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //sets json_string of admin data
            json_string1 = result;
            //returns to admin main activity
            returnToAdminMain();
        }
    }

}
