package com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour;

//Activity that gives the user the option to delete or update a certain building

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.MalformedInputException;


public class Delete_Update_Building extends AppCompatActivity {

    //json data variables
    String json_string1;
    String json_string2;
    String json_string3;
    JSONObject jsonObject2;
    JSONArray jsonArray2;

    String pos;
    int position;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_delete__update__building);

        String id, type, name = null, lat, log;

        //get json data from intents and postion on building from the listview
        json_string1 = getIntent().getExtras().getString("json_data");
        json_string2 = getIntent().getExtras().getString("json_building_data");
        pos = getIntent().getExtras().getString("position");
        position = Integer.parseInt(pos);

        try {
            jsonObject2 = new JSONObject(json_string2);
            jsonArray2 = jsonObject2.getJSONArray("result");

            int count = 0;

            //goes through json string until selected building is choosen to set building_name as a textview on the screen
            while (count <= position) {
                JSONObject JO = jsonArray2.getJSONObject(count);
                id = JO.getString("building_id");
                type = JO.getString("building_type_id");
                name = JO.getString("building_name");
                lat = JO.getString("building_lat");
                log = JO.getString("building_long");

                count++;
            }
        }catch(JSONException e){
            e.printStackTrace();
        }

        //set selected building name in the textview
        TextView buildingName = (TextView)findViewById(R.id.buildingName);
        buildingName.setText(name);
    }

    //overrides back button to send user back to admin main activity
    @Override
    public void onBackPressed(){
        Intent intent = new Intent(this, Admin_Main.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //when delete button is pressed
    public void deleteBuilding(View view) {
        String id = null, type, name, lat, log;

        try {
            jsonObject2 = new JSONObject(json_string2);
            jsonArray2 = jsonObject2.getJSONArray("result");

            int count = 0;

            //increments until the selected building is arrived to in the json_string
            while (count <= position) {
                    JSONObject JO = jsonArray2.getJSONObject(count);
                    id = JO.getString("building_id");
                    type = JO.getString("building_type_id");
                    name = JO.getString("building_name");
                    lat = JO.getString("building_lat");
                    log = JO.getString("building_long");

                count++;
            }
        }catch(JSONException e){
            e.printStackTrace();
        }

        //calls php script that deletes building from the database
        BackgroundTask backgroundTask = new BackgroundTask(this);
        backgroundTask.execute(id);
    }

    //when update button selected
    public void updateBuilding(View view) {
        new BackgroundTask2().execute();
    }

    //moves to updated building activity
    public void updateBuildings()
    {
        String position2 = Integer.toString(position);
        Intent intent = new Intent(this, Update_Building.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        intent.putExtra("json_full_building_data", json_string3);
        intent.putExtra("position", position2);
        startActivity(intent);
    }

    //returns user to admin main activity
    public void returnToAdminMain() {
        Intent intent = new Intent(this, Admin_Main.class);
        intent.putExtra("json_data", json_string1);
        intent.putExtra("json_building_data", json_string2);
        startActivity(intent);
    }

    //calls php script that deletes buildings from the database
    public class BackgroundTask extends AsyncTask<String, Void, String> {

        Context ctx;
        BackgroundTask(Context ctx){
            this.ctx = ctx;
        }
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            String id = params[0];

            try{
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/delete_building.php");
                //opens http connection, output stream, and buffer
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setDoOutput(true);
                OutputStream OS = httpURLConnection.getOutputStream();
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(OS, "UTF-8"));
                String data = URLEncoder.encode("building_id", "UTF-8") +"="+URLEncoder.encode(id, "UTF-8");
                bufferedWriter.write(data);
                bufferedWriter.flush();

                //closes buffer and output stream
                bufferedWriter.close();
                OS.close();
                InputStream IS = httpURLConnection.getInputStream();
                IS.close();
            } catch (MalformedInputException e){
                e.printStackTrace();
            } catch (IOException e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //Toast.makeText(ctx, result, Toast.LENGTH_LONG).show();
            //gets updated json string of building_info table in databse post deletion
            new BackgroundTask1().execute();
        }
    }

    //retrieves updated json string of buildings following deletion of a building
    class BackgroundTask1 extends AsyncTask<Void, Void, String>
    {
        String JSON_String;

        @Override
        protected String doInBackground(Void... params) {
            try {
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/building_info.php");

                //opens http connect, input stream, and buffer
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferReader = new BufferedReader(new InputStreamReader(inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while((JSON_String = bufferReader.readLine())!= null)
                {
                    stringBuilder.append(JSON_String + "\n");
                }

                //closes buffer, input stream, and http connection
                bufferReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                json_string2 = stringBuilder.toString().trim();
                return stringBuilder.toString().trim();
            } catch (MalformedInputException e){
                e.printStackTrace();
            } catch (IOException e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //sets json_string of building_info data
            json_string2 = result;
            //returns to admin main activity
            returnToAdminMain();
        }
    }

    //retrieves updated json string of buildings following deletion of a building
    class BackgroundTask2 extends AsyncTask<Void, Void, String> {
        String JSON_String;

        @Override
        protected String doInBackground(Void... params) {
            try {
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/building_page.php");

                //opens http connect, input stream, and buffer
                HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferReader = new BufferedReader(new InputStreamReader(inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while ((JSON_String = bufferReader.readLine()) != null) {
                    stringBuilder.append(JSON_String + "\n");
                }

                //closes buffer, input stream, and http connection
                bufferReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                json_string3 = stringBuilder.toString().trim();
                return stringBuilder.toString().trim();
            } catch (MalformedInputException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //sets json_string of building_info data
            json_string3 = result;
            //moves to updated building activity
            updateBuildings();
        }
    }
}
