package com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour;

//main user screen, allows user to see points on campus, click for more info, and point at a physical building for more info

import android.Manifest;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.Location;
import android.net.Uri;
import android.os.AsyncTask;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentActivity;
import android.os.Bundle;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.MalformedInputException;


public class SNC_Augemented_Reality_Virtual_Tour extends AppCompatActivity implements locationProvider.LocationCallback, GoogleMap.OnMarkerClickListener, SensorEventListener{

    public static final String TAG = SNC_Augemented_Reality_Virtual_Tour.class.getSimpleName();

    //Map object name
    private GoogleMap mMap;

    //to hold location provider
    private locationProvider mLocationProvider;

    //to hold my current location
    private Location myLocation;

    //Listview for listDrawer
    private ListView mDrawerList;
    private ArrayAdapter<String> mAdapter;

    //Drawer open or close, drawer layout, and title
    private ActionBarDrawerToggle mDrawerToggle;
    private DrawerLayout mDrawerLayout;
    private String mActivityTitle;

    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    private GoogleApiClient client;

    //Cumpass sensor manager and textfield
    private SensorManager sensorManager;
    TextView txtDegrees;

    //Strings, object, and array from database info
    String json_string;
    JSONObject jsonObject;
    JSONArray jsonArray;
    String json_string2;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_snc__augemented__reality__virtual__tour);
        setUpMapIfNeeded();
        getSupportActionBar().setTitle("Home"); //Set title


        mLocationProvider = new locationProvider(this, this);
        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();

        txtDegrees = (TextView) findViewById(R.id.txtDegrees); //Initiate Textview for degrees
        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE); //Initiate compass sensor

        Button buildingInfo = (Button) findViewById(R.id.button); //Initiate AR button

        assert buildingInfo != null;
        //When button is clicked
        buildingInfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //retrieves database info on all buildings in the database
                BackgroundTask1 backgroundTask1 = new BackgroundTask1(SNC_Augemented_Reality_Virtual_Tour.this);
                backgroundTask1.execute("0");
            }
        });

        //Initiates Drawer/Actionbar
        mDrawerList = (ListView) findViewById(R.id.navList);
        mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
        mActivityTitle = getTitle().toString();

        addDrawerItems();
        setupDrawer();

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
    }

    //Calculates if a phone is pointed at a building and finds the closest building if two buildings qualify
    public void calculate()
    {

        //Closest building in meters
        double closest = -1;
        //Building that is compared against closest to find smallest distance
        double contender = -1;
        //Name of closest builing
        String closest_name = null;

        //gets all building info in the database
        try {
            jsonObject = new JSONObject(json_string2);
            jsonArray = jsonObject.getJSONArray("result");
            int count = 0;
            String id, type, name, lat, log, nickname, address, description, url2, pic;

            while (count < jsonArray.length()) {
                JSONObject JO = jsonArray.getJSONObject(count);
                id = JO.getString("building_id");
                type = JO.getString("building_type_id");
                name = JO.getString("building_name");
                lat = JO.getString("building_lat");
                log = JO.getString("building_long");
                nickname = JO.getString("building_nickname");
                address = JO.getString("building_address");
                description = JO.getString("building_description");
                url2 = JO.getString("building_weblink");
                pic = JO.getString("building_pic");

                count++;

                //finds building latitude and longitude
                double lat_a = Double.parseDouble(lat);
                double lng_a = Double.parseDouble(log);

                //Users current latitude and longitude
                double lat_b = myLocation.getLatitude();
                double lng_b = myLocation.getLongitude();

                //http://stackoverflow.com/questions/120283/how-can-i-measure-distance-and-create-a-bounding-box-based-on-two-latitudelongi
                //calculates the distance between two points
                double earthRadius = 3958.75;
                double latDiff = Math.toRadians(lat_b - lat_a);
                double lngDiff = Math.toRadians(lng_b - lng_a);
                double a = Math.sin(latDiff / 2) * Math.sin(latDiff / 2) +
                        Math.cos(Math.toRadians(lat_a)) * Math.cos(Math.toRadians(lat_b)) *
                                Math.sin(lngDiff / 2) * Math.sin(lngDiff / 2);
                double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
                double distance = earthRadius * c;

                int meterConversion = 1609;

                Double inMeters = (distance * meterConversion);

                //Toast.makeText(SNC_Augemented_Reality_Virtual_Tour.this, Double.toString(inMeters), Toast.LENGTH_SHORT).show();

                //Calculates which direction a building is from the user's phone in degrees and the direction the phone is pointing
                //if a building is within 100 meters
                if (inMeters <= 100) {
                    double y = Math.sin(lng_b - lng_a) * Math.cos(lat_b);
                    double x = Math.cos(lat_a) * Math.sin(lat_b) - Math.sin(lat_a) * Math.cos(lat_b) * Math.cos(lng_b - lng_a);

                    double angle = Math.atan2(y, x);
                    if(angle < 0)
                    {
                        angle = angle + (Math.PI);
                    }
                    angle = Math.toDegrees(angle);

                    //Sets direction phone is pointing to the textview
                    String direction = txtDegrees.getText().toString();
                    direction = direction.substring(10, 13);

                    float temp = Float.parseFloat(direction);

                    //Toast.makeText(SNC_Augemented_Reality_Virtual_Tour.this, Double.toString(angle), Toast.LENGTH_SHORT).show();

                    //checks if angle the phone is pointing is within 30 degress of the the buildings direction from the phone's pointed direction
                    //thank you to Linsey Zwiefelhofer for sitting with me and accounting for all situations below
                    if (angle + 15 >= 360) {
                        if ((temp >= angle - 15) && (temp <= 360)) {
                            if(closest == -1){
                                closest = inMeters;
                                closest_name = name;
                            }
                            else{
                                contender = inMeters;
                            }
                        } else if ((temp >= 0) && (temp <= ((angle + 15) % 360))) {
                            if(closest == -1){
                                closest = inMeters;
                                closest_name = name;
                            }
                            else{
                                contender = inMeters;
                            }
                        }
                    } else if (angle - 15 <= 0) {
                        if ((temp <= angle + 15) && (temp >= 0)) {
                            if(closest == -1){
                                closest = inMeters;
                                closest_name = name;
                            }
                            else{
                                contender = inMeters;
                            }
                        } else if ((temp >= ((angle - 15) + 360)) && (temp <= 360)) {
                            if (closest == -1) {
                                closest = inMeters;
                                closest_name = name;
                            } else {
                                contender = inMeters;
                            }
                        }
                    } else if ((((angle + 15) % 360) >= temp) && ((((angle - 15) + 360) % 360) <= temp) && ((angle + 15) <= 360) && ((angle - 15) >= 0)) {
                        if(closest == -1){
                            closest = inMeters;
                            closest_name = name;
                        }
                        else{
                            contender = inMeters;
                        }
                    }
                }
                if(contender < closest)
                {
                    closest = contender;
                    closest_name = name;
                }
            }

            //If building is detected, calls page with building info to appear
            if(closest_name != null){
                Intent intent = new Intent(SNC_Augemented_Reality_Virtual_Tour.this, Site_Info.class);
                intent.putExtra("json_string", json_string2);
                intent.putExtra("Title", closest_name);
                startActivity(intent);
            }
        }
        catch (JSONException e){
            e.printStackTrace();
        }
    }

    //Overrides the back button so that it returns the app to the device's home screen
    @Override
    public void onBackPressed(){
        Intent a = new Intent(Intent.ACTION_MAIN);
        a.addCategory(Intent.CATEGORY_HOME);
        a.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(a);
    }

    //
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        // Activate the navigation drawer toggle
        if (mDrawerToggle.onOptionsItemSelected(item)) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    //For when the activity resumes
    @Override
    protected void onResume() {
        super.onResume();
        setUpMapIfNeeded();
        mLocationProvider.connect();

        sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION), SensorManager.SENSOR_DELAY_GAME);
    }

    //When the activity is put on pause
    @Override
    protected void onPause() {
        super.onPause();
        mLocationProvider.disconnect();

        sensorManager.unregisterListener(this);
    }

    /**
     * Sets up the map if it is possible to do so (i.e., the Google Play services APK is correctly
     * installed) and the map has not already been instantiated.. This will ensure that we only ever
     * call {@link #setUpMap()} once when {@link #mMap} is not null.
     * <p/>
     * If it isn't installed {@link SupportMapFragment} (and
     * {@link MapView MapView}) will show a prompt for the user to
     * install/update the Google Play services APK on their device.
     * <p/>
     * A user can return to this FragmentActivity after following the prompt and correctly
     * installing/updating/enabling the Google Play services. Since the FragmentActivity may not
     * have been completely destroyed during this process (it is likely that it would only be
     * stopped or paused), {@link #onCreate(Bundle)} may not be called again so we should call this
     * method in {@link #onResume()} to guarantee that it will be called.
     */
    private void setUpMapIfNeeded() {
        // Do a null check to confirm that we have not already instantiated the map.
        if (mMap == null) {
            // Try to obtain the map from the SupportMapFragment.
            SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
            mapFragment.getMapAsync(new OnMapReadyCallback() {
                @Override
                public void onMapReady(GoogleMap googleMap) {
                    mMap = googleMap;
                    setUpMap();
                }
            });
            //mMap.addMarker(new MarkerOptions().position(new LatLng(0, 0)).title("Marker"));
            // Check if we were successful in obtaining the map.
            /*if (mMap != null) {
                setUpMap();
            }*/
        }
    }


    /**
     * This is where we can add markers or lines, add listeners or move the camera. In this case, we
     * just add a marker near Africa.
     * <p/>
     * This should only be called once and when we are sure that {@link #mMap} is not null.
     */
    private void setUpMap() {
        mMap.addMarker(new MarkerOptions().position(new LatLng(0, 0)).title("Marker"));
    }

    //Handles the user's new location
    public void handleNewLocation(Location location) {
        Log.d(TAG, location.toString());

        myLocation = location;

        //gets user's current location
        double currentLatitude = myLocation.getLatitude();
        double currentLongitude = myLocation.getLongitude();
        LatLng latLng = new LatLng(currentLatitude, currentLongitude);

        mMap.clear();

        //mMap.addMarker(new MarkerOptions().position(new LatLng(currentLatitude, currentLongitude)).title("Current Location"));

        //Sets marker at user's current location
        MarkerOptions options = new MarkerOptions()
                .position(latLng)
                .title("You Are Here");
        mMap.addMarker(options);
        mMap.moveCamera(CameraUpdateFactory.newLatLng(latLng));

        //Moves camera to current location
        CameraPosition cameraPosition = new CameraPosition.Builder()
                .target(new LatLng(location.getLatitude(), location.getLongitude()))      // Sets the center of the map to location user
                .zoom(17)                   // Sets the zoom
                .build();                   // Creates a CameraPosition from the builder
        mMap.animateCamera(CameraUpdateFactory.newCameraPosition(cameraPosition));
    }

    @Override
    public void onStart() {
        super.onStart();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client.connect();
        Action viewAction = Action.newAction(
                Action.TYPE_VIEW, // TODO: choose an action type.
                "SNC_Augemented_Reality_Virtual_Tour Page", // TODO: Define a title for the content shown.
                // TODO: If you have web page content that matches this app activity's content,
                // make sure this auto-generated web page URL is correct.
                // Otherwise, set the URL to null.
                Uri.parse("http://host/path"),
                // TODO: Make sure this auto-generated app deep link URI is correct.
                Uri.parse("android-app://com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour/http/host/path")
        );
        AppIndex.AppIndexApi.start(client, viewAction);
    }

    @Override
    public void onStop() {
        super.onStop();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        Action viewAction = Action.newAction(
                Action.TYPE_VIEW, // TODO: choose an action type.
                "SNC_Augemented_Reality_Virtual_Tour Page", // TODO: Define a title for the content shown.
                // TODO: If you have web page content that matches this app activity's content,
                // make sure this auto-generated web page URL is correct.
                // Otherwise, set the URL to null.
                Uri.parse("http://host/path"),
                // TODO: Make sure this auto-generated app deep link URI is correct.
                Uri.parse("android-app://com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour/http/host/path")
        );
        AppIndex.AppIndexApi.end(client, viewAction);
        client.disconnect();
    }

    //Required, unsused
    @Override
    public void onAccuracyChanged(Sensor p1, int p2)
    {
    }

    //Updates degrees textView when the direction the phone points changes
    @Override
    public void onSensorChanged(SensorEvent event)
    {
        float degree=Math.round(event.values[0]);
        txtDegrees.setText("Rotation: " + Float.toString(degree) + " degrees");
        //currentDegree=-degree;
    }

    //Sets drawer items to the drawer array
    private void addDrawerItems() {
        String[] osArray = { "Home", "Academic Buildings", "Food", "Residence Halls/Apartments", "Miscellaneous", "All Buildings", "Admin Login" };
        mAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, osArray);
        mDrawerList.setAdapter(mAdapter);

        //does action depending on which drawer item is selected
        mDrawerList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                if (id == 0) {
                    backToHome();
                }
                if (id == 1) {
                    getAcademicBuildings();
                    DrawerLayout mDrawerLayout;
                    mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
                    mDrawerLayout.closeDrawers();
                }
                if (id == 2) {
                    getFood();
                    DrawerLayout mDrawerLayout;
                    mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
                    mDrawerLayout.closeDrawers();
                }
                if (id == 3) {
                    getResAprt();
                    DrawerLayout mDrawerLayout;
                    mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
                    mDrawerLayout.closeDrawers();
                }
                if (id == 4) {
                    getMiscellaneous();
                    DrawerLayout mDrawerLayout;
                    mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
                    mDrawerLayout.closeDrawers();
                }
                if (id == 5) {
                    getAcademicBuildings();
                    getFood();
                    getResAprt();
                    getMiscellaneous();
                    DrawerLayout mDrawerLayout;
                    mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
                    mDrawerLayout.closeDrawers();
                }
                if (id == 6) {
                    Intent intent = new Intent(SNC_Augemented_Reality_Virtual_Tour.this, Admin_Login.class);
                    startActivity(intent);
                }
            }
        });
    }

    private void setupDrawer() {
        mDrawerToggle = new ActionBarDrawerToggle(this, mDrawerLayout,
                R.string.drawer_open, R.string.drawer_close) {

            /** Called when a drawer has settled in a completely open state. */
            public void onDrawerOpened(View drawerView) {
                super.onDrawerOpened(drawerView);
                getSupportActionBar().setTitle("Select:");
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }

            /** Called when a drawer has settled in a completely closed state. */
            public void onDrawerClosed(View view) {
                super.onDrawerClosed(view);
                getSupportActionBar().setTitle("Home");
                invalidateOptionsMenu(); // creates call to onPrepareOptionsMenu()
            }
        };

        mDrawerToggle.setDrawerIndicatorEnabled(true);
        mDrawerLayout.setDrawerListener(mDrawerToggle);
    }

    //Auto-generated code
    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        mDrawerToggle.syncState();
    }

    //Auto-generated code
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        mDrawerToggle.onConfigurationChanged(newConfig);
    }

    //Item 0 of item drawer selected, reloads home screen
    public void backToHome(){
        Intent mStartActivity = new Intent(SNC_Augemented_Reality_Virtual_Tour.this, SNC_Augemented_Reality_Virtual_Tour.class);
        startActivity(mStartActivity);
    }

    //Item 1 of item drawer selected
    //Gets all academic buildings from the database
    public void getAcademicBuildings() {

        String id = "1";

        BackgroundTask backgroundTask = new BackgroundTask(this);
        backgroundTask.execute(id);
    }

    //Item 2 of item drawer selected
    //Gets all food buildings from the database
    public void getFood(){
        String id = "2";

        BackgroundTask backgroundTask = new BackgroundTask(this);
        backgroundTask.execute(id);
    }

    //Item 3 of item drawer selected
    //Gets all Residential buildings from the database
    public void getResAprt() {
        String id = "3";

        BackgroundTask backgroundTask = new BackgroundTask(this);
        backgroundTask.execute(id);
    }

    //Item 4 of item drawer selected
    //Gets all miscellaneous buildings from the database
    public void getMiscellaneous(){
        String id = "4";

        BackgroundTask backgroundTask = new BackgroundTask(this);
        backgroundTask.execute(id);
    }

    //If a marker is clicked that isn't user's marker, building title appears and building info activity begins
    @Override
    public boolean onMarkerClick(final Marker marker) {

        String title = marker.getTitle().trim();
        if (title.equals("You Are Here"))
        {
            return false;
        }
        else if (mMap.getCameraPosition().zoom < 16){
            return false;
        }
        else{

            Intent intent = new Intent(SNC_Augemented_Reality_Virtual_Tour.this, Site_Info.class);
            intent.putExtra("Title", marker.getTitle().trim());
            intent.putExtra("json_string", json_string2);
            startActivity(intent);
            //Toast.makeText(SNC_Augemented_Reality_Virtual_Tour.this, marker.getTitle(), Toast.LENGTH_SHORT).show();
            return false;
        }
    }

    //Gets data from json string and loads it into variables
    //creates marker for each building type based of the string helper value
    public void parseBuildings(String helper){
        try {
            jsonObject = new JSONObject(json_string);
            jsonArray = jsonObject.getJSONArray("result");
            int count = 0;
            String b_id, type, name, lat, log;

            while(count < jsonArray.length())
            {
                JSONObject JO = jsonArray.getJSONObject(count);
                b_id = JO.getString("building_id");
                type = JO.getString("building_type_id");
                name = JO.getString("building_name");
                lat = JO.getString("building_lat");
                log = JO.getString("building_long");

                double Latitude = Double.parseDouble(lat);
                double Longitude = Double.parseDouble(log);

                LatLng latLng = new LatLng(Latitude, Longitude);

                mMap.setOnMarkerClickListener(this);

                //If academic buildings drawer item is selected
                if(helper.equals("1")) {
                    MarkerOptions options = new MarkerOptions()
                            .position(latLng)
                            .title(name)
                            .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_AZURE));
                    mMap.addMarker(options);
                } //If food buildings drawer item is selected
                else if(helper.equals("2")) {
                    MarkerOptions options = new MarkerOptions()
                            .position(latLng)
                            .title(name)
                            .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_ORANGE));
                    mMap.addMarker(options);
                } //If residential/Apartment building drawer item is selected
                else if(helper.equals("3")) {
                    MarkerOptions options = new MarkerOptions()
                            .position(latLng)
                            .title(name)
                            .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_VIOLET));
                    mMap.addMarker(options);
                } //If miscellaneous building drawer item is selected
                else if(helper.equals("4")) {
                    MarkerOptions options = new MarkerOptions()
                            .position(latLng)
                            .title(name)
                            .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_YELLOW));
                    mMap.addMarker(options);
                }

                count++;
            }
        }
        catch (JSONException e) {
            e.printStackTrace();
        }

        //double currentLatitude = 44.444818;
        //double currentLongitude = -88.066599;
        //LatLng latLng = new LatLng(currentLatitude, currentLongitude);

        //mMap.setOnMarkerClickListener(this);

        //MarkerOptions options = new MarkerOptions()
        //        .position(latLng)
        //        .title("Boyle Hall")
        //        .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_AZURE));
        //mMap.addMarker(options);

        //double lat_b = 44.445806;
        //double lng_b = -88.065859;
        //LatLng loc = new LatLng(lat_b, lng_b);

        //MarkerOptions options1 = new MarkerOptions()
        //       .position(loc)
        //        .title("GMS")
        //        .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_AZURE));
        //mMap.addMarker(options1);

        //Moves camera position to main hall
        CameraPosition cameraPosition = new CameraPosition.Builder()
                .target(new LatLng(44.444075, -88.066556))      // Sets the center of the map to location user
                .zoom(16)                   // Sets the zoom
                .build();                   // Creates a CameraPosition from the builder

        mMap.animateCamera(CameraUpdateFactory.newCameraPosition(cameraPosition));

        //Gets json data for building info page from database
        BackgroundTask1 backgroundTask1 = new BackgroundTask1(SNC_Augemented_Reality_Virtual_Tour.this);
        backgroundTask1.execute("1");
    }

    //Gets json data for buildings depending on what drawer item was selected
    //https://www.youtube.com/watch?v=uFbwW4ERUN0
    public class BackgroundTask extends AsyncTask<String, Void, String> {

        Context ctx;
        BackgroundTask(Context ctx){
            this.ctx = ctx;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        String JSON_String;
        String helper;

        @Override
        protected String doInBackground(String... params) {

            try {
                String id = params[0];
                helper = id;
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/building_info.php");

                //if user selected academic buildings
                if(id.equals("1")) {
                    url = new URL("http://compsci02.snc.edu/~philmt/csci460/academic_buildings.php");
                } //if user selected food buildings
                else if(id.equals("2")) {
                    url = new URL("http://compsci02.snc.edu/~philmt/csci460/foodBuildings.php");
                } //if user selected residential buildings
                else if(id.equals("3")) {
                    url = new URL("http://compsci02.snc.edu/~philmt/csci460/res_buildings.php");
                } //if user selected miscellaneous buildings
                else if(id.equals("4")) {
                    url = new URL("http://compsci02.snc.edu/~philmt/csci460/miscellaneous_buildings.php");
                }

                //establish http connection, opens input stream, reads info from buffers
                HttpURLConnection httpURLConnection = (HttpURLConnection)url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferReader = new BufferedReader(new InputStreamReader(inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while((JSON_String = bufferReader.readLine())!= null)
                {
                    stringBuilder.append(JSON_String + "\n");
                }

                //close buffer and inputstream, disconnects http connection
                bufferReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                json_string = stringBuilder.toString().trim();
                return stringBuilder.toString().trim();
            } catch (MalformedInputException e){
                e.printStackTrace();
            } catch (IOException e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //sets json string
            json_string = result;
            parseBuildings(helper);
        }
    }

    //Gets json data for all buildings from the database
    //https://www.youtube.com/watch?v=uFbwW4ERUN0
    public class BackgroundTask1 extends AsyncTask<String, Void, String> {

        Context ctx;
        BackgroundTask1(Context ctx){
            this.ctx = ctx;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        String JSON_String;
        String helper;

        @Override
        protected String doInBackground(String... params) {

            helper = params[0];

            //establish http connection, opens input stream, reads info from buffers
            try {
                URL url = new URL("http://compsci02.snc.edu/~philmt/csci460/building_page.php");
                HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
                InputStream inputStream = httpURLConnection.getInputStream();
                BufferedReader bufferReader = new BufferedReader(new InputStreamReader(inputStream));
                StringBuilder stringBuilder = new StringBuilder();
                while ((JSON_String = bufferReader.readLine()) != null) {
                    stringBuilder.append(JSON_String + "\n");
                }

                //close buffer and inputstream, disconnects http connection
                bufferReader.close();
                inputStream.close();
                httpURLConnection.disconnect();
                json_string2 = stringBuilder.toString().trim();
                return stringBuilder.toString().trim();
            } catch (MalformedInputException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Void... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected void onPostExecute(String result) {
            //sets json string
            json_string2 = result;

            //if building info button was selected
            if(helper.equals("0")) {
                calculate();
            }
        }
    }
}
