package com.example.sncaugmentedrealityvirtual_tour.snc_augmented_reality_virtual_tour;

//Activity used to display building info

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Html;
import android.text.method.LinkMovementMethod;
import android.util.Base64;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.MalformedInputException;

public class Site_Info extends AppCompatActivity {

    String json_string;
    JSONObject jsonObject;
    JSONArray jsonArray;
    String title;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.content_site__info);
        title = getIntent().getStringExtra("Title"); //gets building title
        json_string = getIntent().getStringExtra("json_string"); //retrieves intent, json_string

        parseBuildings();

    }

    //Overrides back button to return to home screen of the app
    @Override
    public void onBackPressed(){
        Intent intent = new Intent(this, SNC_Augemented_Reality_Virtual_Tour.class);
        startActivity(intent);
    }

    //parses json_string for building whoes title matches title sent via the intent
    //generates page with info retrieved from the database
    public void parseBuildings()
    {
        try{
            jsonObject = new JSONObject(json_string);
            jsonArray = jsonObject.getJSONArray("result");
            int count = 0;
            int cnt = 0;
            String id, type, name, lat, log, nickname, address, description, url2, pic;

            //from json_string, gets building info
            while(count < jsonArray.length())
            {
                JSONObject JO = jsonArray.getJSONObject(count);
                id = JO.getString("building_id");
                type = JO.getString("building_type_id");
                name = JO.getString("building_name");
                lat = JO.getString("building_lat");
                log = JO.getString("building_long");
                nickname = JO.getString("building_nickname");
                address = JO.getString("building_address");
                description = JO.getString("building_description");
                url2 = JO.getString("building_weblink");
                pic = JO.getString("building_pic");


                if(name.equals(title)){
                    //sets building title textview
                    TextView building_title = (TextView)findViewById(R.id.building_title);
                    building_title.setText(name);

                    //sets building nickname textview
                    TextView building_nickname = (TextView)findViewById(R.id.building_nickname);
                    building_nickname.setText("(" + nickname + ")");

                    //sets building description textview
                    TextView building_desc = (TextView)findViewById(R.id.building_desc);
                    building_desc.setText(description);

                    //sets building address textview
                    TextView building_add = (TextView)findViewById(R.id.building_add);
                    building_add.setText(address);

                    //sets building url link textview
                    TextView building_link = (TextView)findViewById(R.id.building_link);
                    building_link.setText(Html.fromHtml(url2));

                    //decodes building picture
                    Bitmap bm = BitmapFactory.decodeFile(pic);
                    ByteArrayOutputStream baos = new ByteArrayOutputStream();
                    bm.compress(Bitmap.CompressFormat.PNG, 100, baos); //bm is the bitmap object
                    byte[] b = baos.toByteArray();

                    //String encodedImage = Base64.encodeToString(b, Base64.DEFAULT);

                    //sets building picture imageView
                    ImageView imageView = (ImageView)findViewById(R.id.imageView);
                    imageView.setImageBitmap(BitmapFactory
                            .decodeByteArray(b, 0, b.length));

                    cnt++;
                }
                else if(cnt == 0)
                {
                    Toast.makeText(getApplicationContext(), "Location is not in our database", Toast.LENGTH_LONG).show();
                }
                count++;
            }
        }
        catch (JSONException e){
            e.printStackTrace();
        }
    }
}
